(* Title:  collect all defitions for xml generation and libisabelle (Las Hupel)
   Author: Walther Neuper 110226
   (c) due to copyright terms

Since libisabelle has been discontinued, this directory will disappear eventually.
Respective code will be deleted or located elsewhere.
*)

theory BridgeLibisabelle
  imports "$ISABELLE_ISAC/Test_Code/Test_Code"
begin
  ML_file "pbl-met-hierarchy.sml" (*keep as a model for browsing pbl and met hierarchies*)
  ML_file "present-tool.sml"      (*keep tests of interaction Java-frontend <-> Kernel running*)
  ML_file mathml.sml              (*keep tests of interaction Java-frontend <-> Kernel running*)
  ML_file datatypes.sml           (*keep tests of interaction Java-frontend <-> Kernel running*)
  ML_file "interface-xml.sml"     (*keep tests of interaction Java-frontend <-> Kernel running*)
  ML_file interface.sml           (*keep tests of interaction Java-frontend <-> Kernel running*)

ML \<open>
\<close> ML \<open>
(*T_TESTold*)
fun xml_of_itm_ (I_Model.Cor (dts, _)) =
    XML.Elem (("ITEM", [("status", "correct")]), [xml_of_term (Input_Descript.join' dts)])
  | xml_of_itm_ (I_Model.Syn c) =
    XML.Elem (("ITEM", [("status", "syntaxerror")]), [XML.Text c])
  | xml_of_itm_ (I_Model.Typ c) =
    XML.Elem (("ITEM", [("status", "typeerror")]), [XML.Text c])
  (*type item also has 'False of cterm' set in preconds2xml WN 050618*)
  | xml_of_itm_ (I_Model.Inc (dts, _)) = 
    XML.Elem (("ITEM", [("status", "incomplete")]), [xml_of_term (Input_Descript.join' dts)])
  | xml_of_itm_ (I_Model.Sup dts) = 
    XML.Elem (("ITEM", [("status", "superfluous")]), [xml_of_term (Input_Descript.join' dts)])
  | xml_of_itm_ (I_Model.Mis (d, pid)) = 
    XML.Elem (("ITEM", [("status", "missing")]), [xml_of_term (d $ pid)])
  | xml_of_itm_ _ = raise ERROR "xml_of_itm_: wrong argument"
fun xml_of_itms itms =
  let 
    fun extract (_, _, _, _, itm_) = itm_
  in map (xml_of_itm_ o extract) itms end
(*T_TEST*)
fun xml_of_itm_TEST (I_Model.Cor_TEST (dts, _)) =
    XML.Elem (("ITEM", [("status", "correct")]), [xml_of_term (Input_Descript.join' dts)])
  | xml_of_itm_TEST (I_Model.Syn_TEST c) =
    XML.Elem (("ITEM", [("status", "syntaxerror")]), [XML.Text c])
  | xml_of_itm_TEST (I_Model.Inc_TEST (dts, _)) = 
    XML.Elem (("ITEM", [("status", "incomplete")]), [xml_of_term (Input_Descript.join' dts)])
  | xml_of_itm_TEST (I_Model.Sup_TEST dts) = 
    XML.Elem (("ITEM", [("status", "superfluous")]), [xml_of_term (Input_Descript.join' dts)])
fun xml_of_itms_TEST itms =
  let 
    fun extract (_, _, _, _, itm_) = itm_
  in map (xml_of_itm_TEST o extract) itms end
(*T_TESTnew*)
\<close> ML \<open>
\<close>
end
